# Share your Flutter architecture with a website

One of the first things that catches me with Dart is the ability to compiles it to efficient native code (i.e. mobile), to be interpreted from a virtual machine (i.e. desktop) or to be transpiled to javascript (i.e. web). But it turns out that it is not used as much as I expected to share large portions of code between all those plaforms.

## Disparate technologies

The main reason for me is that the approaches and architectures for these targets aren't thought as a coherent ecosystem yet... maybe because of the Dart story.

* **Mobile** : the official solution is [Flutter](https://flutter.io) which encourages developers to adopt a reactive programming model, with an update loop base on immutable states. One of the recommanded pattern is [BloC](https://medium.com/flutter-io/build-reactive-mobile-apps-in-flutter-companion-article-13950959e381).
* **Web** : the official solution is [Angular-Dart](https://webdev.dartlang.org/angular) which is more based on the MVC/MVVM pattern where you mutate states and the user interface is notified and should update itself accordingly.
* **Desktop** : mainly used for console programs and tools. No particular recommended way.

So, if we want to share some code between our web and mobile app we have to potential options : adapt the MVVM approach for mobile, or adapt the reactive approach for web.

## Reactive web with React

Since I love the reactive approach of Flutter I searched to adopt it for building websites. Since React is really similar to Flutter 

## Conclusion

For me, Google should really invest more in React-like solutions to push a lot more this code sharing strategy. Thanks to the [dart-react](https://github.com/cleandart/react-dart) team, it is possible today, but not enough known since Google pushes a lot Angular.